<?php

/**
 *  Plugin require a code edit, in inc/class_moderation.php, find (first instance only):
 *    ++$forum_counters[$post['fid']]['num_posts'];
 *  add below:
 *    if(function_exists('softdeletex_approveposts')) eval(softdeletex_approveposts($post));
 *  For MyBB 1.6, the edit needs to be placed outside the if statement
 */



if(!defined('IN_MYBB'))
	die('This file cannot be accessed directly.');


if(defined('IN_ADMINCP')) {
	require MYBB_ROOT.'inc/plugins/softdelete/sd_admin.php';
}

$modfile = MYBB_ROOT.'inc/plugins/softdelete/sd_moderation.php';
$plugins->add_hook('class_moderation_delete_thread_start', 'softdelete_delthread', -9999, $modfile);
$plugins->add_hook('class_moderation_delete_post_start', 'softdelete_delpost', -9999, $modfile);

$plugins->add_hook('class_moderation_approve_threads', 'softdelete_approvethreads', 10, $modfile);
$plugins->add_hook('class_moderation_split_posts', 'softdelete_splitpost_fix', 10, $modfile);
$plugins->add_hook('class_moderation_merge_threads', 'softdelete_mergethread_fix', 10, $modfile);
$plugins->add_hook('class_moderation_copy_thread', 'softdelete_copythread_fix', 10, $modfile);

$plugins->add_hook('moderation_start', 'softdelete_moderation', 10, $modfile);
$plugins->add_hook('moderation_do_split', 'softdelete_moderation_block_mergesplit', 10, $modfile);
$plugins->add_hook('moderation_do_mergeposts', 'softdelete_moderation_block_mergesplit', 10, $modfile);
$plugins->add_hook('moderation_do_deletethread', 'softdelete_moderation_purge_thread', 1, $modfile);
$plugins->add_hook('moderation_do_deleteposts', 'softdelete_moderation_purge_posts', 1, $modfile);


$plugins->add_hook('modcp_start', 'softdelete_modcp', 10, MYBB_ROOT.'inc/plugins/softdelete/sd_modcp.php');

$miscfile = MYBB_ROOT.'inc/plugins/softdelete/sd_misc.php';


$plugins->add_hook('search_results_start', 'softdelete_search', 10, $miscfile);
// following have a priority of 20 for compatibility with XThreads
$plugins->add_hook('search_results_thread', 'softdelete_search_thread', 20, $miscfile);
$plugins->add_hook('search_results_post', 'softdelete_search_post', 20, $miscfile);

$plugins->add_hook('forumdisplay_start', 'softdelete_forumdisplay');
function softdelete_forumdisplay() {
	$tpl =& $GLOBALS['templates']->cache['forumdisplay_inlinemoderation'];
	global $lang;
	$rpl = array('{$lang->approve_threads}' => '{$lang->approve_undelete_threads}');
	if($GLOBALS['mybb']->usergroup['cancp']) {
		$rpl['<option value="multideletethreads">{$lang->delete_threads}</option>'] = '<option value="multideletethreads">{$lang->delete_threads}</option><option value="do_multipurgethreads">{$lang->purge_threads}</option>';
		($lang->purge_threads) or $lang->purge_threads = 'Purge Deleted Threads';
	}
	($lang->approve_undelete_threads) or $lang->approve_undelete_threads = 'Approve/Undelete Threads';
	$tpl = strtr($tpl, $rpl);
	
	// fix pagination too
	control_object($GLOBALS['db'], '
		function simple_select($table, $fields="*", $conditions="", $options=array()) {
			if($table == "forums" && $fields == "threads, unapprovedthreads" && $options["limit"] == 1) {
				$fields = "threads, unapprovedthreads+deletedthreads AS unapprovedthreads";
			}
			return parent::simple_select($table, $fields, $conditions, $options);
		}
	');
}
$plugins->add_hook('showthread_start', 'softdelete_showthread');
function softdelete_showthread() {
	global $thread, $lang;
	if($thread['deleted']) {
		global $forumpermissions, $user_cache, $mybb, $forum, $plugins;
		
		//$mybb->usergroup['issupermod'] = 0;
		$forum['open'] = 0;
		
		if(!$user_cache[$mybb->user['uid']])
			user_permissions($mybb->user['uid']);
		$uc_perms =& $user_cache[$mybb->user['uid']]['permissions'];
		
		$disablefields = array('canpostreplys', 'canpostattachments', 'canratethreads', 'caneditposts', 'candeleteposts', 'candeletethreads', 'canpostpolls', 'canvotepolls', 'canundovotes');
		foreach($disablefields as $field) {
			$forumpermissions[$field] = 0;
			$uc_perms[$field] = 0;
			$mybb->usergroup[$field] = 0;
		}
		// moderator perms?
		
		function softdelete_showthread_ismod() {
			unset($GLOBALS['adminpolloptions']);
			$tc =& $GLOBALS['templates']->cache;
			$tc['showthread_inlinemoderation_custom_tool'] = $tc['showthread_moderationoptions_custom_tool'] = $tc['showthread_inlinemoderation_custom'] = $tc['showthread_inlinemoderation'] = $tc['showthread_moderationoptions_custom'] = $tc['showthread_moderationoptions'] = '';
			$tc['postbit_edit'] = $tc['postbit_quickdelete'] = $tc['postbit_inlinecheck'] = $tc['postbit_quote'] = $tc['postbit_multiquote'] = '';
		}
		$plugins->add_hook('showthread_ismod', 'softdelete_showthread_ismod');
	} else {
		$tpl =& $GLOBALS['templates']->cache['showthread_inlinemoderation'];
		$rpl = array('{$lang->inline_approve_posts}' => '{$lang->inline_approve_undelete_threads}');
		if($GLOBALS['mybb']->usergroup['cancp']) {
			$rpl['<option value="multideleteposts">{$lang->inline_delete_posts}</option>'] = '<option value="multideleteposts">{$lang->inline_delete_posts}</option><option value="do_multipurgeposts">{$lang->inline_purge_posts}</option>';
			($lang->inline_purge_posts) or $lang->inline_purge_posts = 'Purge Deleted Posts';
		}
		($lang->inline_approve_undelete_threads) or $lang->inline_approve_undelete_threads = 'Approve/Undelete Posts';
		$tpl = strtr($tpl, $rpl);
		
		// unnecessary, as, if thread is deleted, can't see the listbox
		//($lang->approve_undelete_thread) or $lang->approve_undelete_thread = 'Approve/Undelete Thread';
		//$lang->approve_thread = $lang->approve_undelete_thread;
	}
}

$plugins->add_hook('editpost_start', 'softdelete_block_editpost', 10, $miscfile);
$plugins->add_hook('newreply_start', 'softdelete_block_newreply', 10, $miscfile);
$plugins->add_hook('newreply_do_newreply_start', 'softdelete_block_newreply', 10, $miscfile);
$plugins->add_hook('polls_editpoll_start', 'softdelete_block_editpoll', 10, $miscfile);
$plugins->add_hook('polls_do_editpoll_start', 'softdelete_block_editpoll', 10, $miscfile);
$plugins->add_hook('polls_newpoll_start', 'softdelete_block_newpoll', 10, $miscfile);
$plugins->add_hook('polls_do_newpoll_start', 'softdelete_block_newpoll', 10, $miscfile);
$plugins->add_hook('polls_vote_start', 'softdelete_block_votepoll', 10, $miscfile);
$plugins->add_hook('polls_do_undovote_start', 'softdelete_block_undovotepoll', 10, $miscfile);
$plugins->add_hook('ratethread_start', 'softdelete_block_ratethread', 10, $miscfile);
$plugins->add_hook('xmlhttp', 'softdelete_block_editajax');
function softdelete_block_editajax() {
	global $mybb;
	if($mybb->input['action'] != 'edit_post') return;
	$post = get_post(intval($mybb->input['pid']));
	if($post['pid']) $thread = get_thread($post['tid']);
	if($thread && $thread['deleted'])
		error_no_permission();
}

$plugins->add_hook('forumdisplay_thread', 'softdelete_fd_thread');
$plugins->add_hook('postbit', 'softdelete_st_post');
function softdelete_fd_thread() {
	global $templates, $thread;
	static $started=false;
	if($thread['deleted']) {
		if(!$started) {
			if(!$templates->cache['forumdisplay_thread'] || !$templates->cache['forumdisplay_thread_deleted'])
				$templates->cache('forumdisplay_thread,forumdisplay_thread_deleted');
			$templates->cache['__softdelete_backup_forumdisplay_thread'] = $templates->cache['forumdisplay_thread'];
			$templates->cache['forumdisplay_thread'] =& $templates->cache['forumdisplay_thread_deleted'];
			$started = true;
		}
		global $lang, $foruminfo, $fpermissions, $delete_span;
		softdelete_delthread_setvars($thread['tid'], $GLOBALS['fid']);
		if($foruminfo['allowtratings'] != 0 && $fpermissions['canviewthreads'] != 0)
			$delete_span = 2;
		else
			$delete_span = 1;
	} elseif($started) {
		$templates->cache['forumdisplay_thread'] =& $templates->cache['__softdelete_backup_forumdisplay_thread'];
		$started = false;
	}
	
	// pagination fix
	global $ismod, $mybb;
	static $hookfix_done = false;
	if(!$mybb->settings['postsperpage']) $mybb->settings['postsperpage'] = 20;
	if($ismod && $thread['deletedposts'] && ($thread['replies'] + $thread['unapprovedposts'] + $thread['deletedposts']) > $mybb->settings['postsperpage']) {
		$thread['__softdelete_restore_unapprovedposts'] = 1;
		$thread['unapprovedposts'] += $thread['deletedposts'];
		if(!$hookfix_done) {
			$hookfix_done = true;
			function softdelete_fd_thread_countfix(&$d) {
				global $thread;
				if(isset($thread['__softdelete_restore_unapprovedposts'])) {
					$thread['unapprovedposts'] -= $thread['deletedposts'];
					unset($thread['__softdelete_restore_unapprovedposts']);
				}
			}
			$GLOBALS['plugins']->add_hook('my_date', 'softdelete_fd_thread_countfix');
		}
	}
}
function softdelete_st_post(&$post) {
	global $templates, $mybb, $thread;
	static $started=false;
	$is_firstpost = (!empty($thread) && $thread['firstpost'] == $post['pid']);
	$target_tpl = ($mybb->settings['postlayout'] == 'classic' ? 'postbit_classic' : 'postbit');
	if($post['deleted'] && !$post['visible'] && !$is_firstpost) {
		if(!$started) {
			if(!$templates->cache[$target_tpl] || !$templates->cache['postbit_deleted'])
				$templates->cache($target_tpl.',postbit_deleted');
			$templates->cache['__softdelete_backup_postbit'] = $templates->cache[$target_tpl];
			$templates->cache[$target_tpl] =& $templates->cache['postbit_deleted'];
			$started = true;
		}
		global $lang, $foruminfo, $fpermissions, $delete_span;
		isset($lang->deleted_post) or $lang->deleted_post = 'Deleted Post';
		isset($lang->show_deleted_post) or $lang->show_deleted_post = 'Show Deleted Post';
		isset($lang->originally_posted_by) or $lang->originally_posted_by = 'Originally posted by {1}';
		$post['original_poster'] = $lang->sprintf($lang->originally_posted_by, build_profile_link($post['username'], $post['uid']));
		$post['deleted_modbuttons'] = '';
		if(is_moderator($post['fid'], 'canmanagethreads')) {
			isset($lang->undelete_post) or $lang->undelete_post = 'Undelete Post';
			$post['deleted_modbuttons'] .= '<a href="moderation.php?action=do_undeletepost&amp;pid='.$post['pid'].'&amp;my_post_key='.$mybb->post_code.'">'.$lang->undelete_post.'</a>';
		}
		if($mybb->usergroup['cancp']) {
			if($post['deleted_modbuttons']) $post['deleted_modbuttons'] .= ' &nbsp; ';
			isset($lang->purge_post) or $lang->purge_post = 'Purge Post';
			$post['deleted_modbuttons'] .= '<a href="moderation.php?action=do_purgepost&amp;pid='.$post['pid'].'&amp;my_post_key='.$mybb->post_code.'">'.$lang->purge_post.'</a>';
		}
	} elseif($started) {
		$templates->cache[$target_tpl] =& $templates->cache['__softdelete_backup_postbit'];
		$started = false;
	}
}

function softdelete_delthread_setvars($id, $fid, $what='thread') { // can also do posts (for search by posts)
	global $lang, $deleted_modbuttons, $mybb;
	if(!$lang->deleted) $lang->deleted = 'Deleted';
	$undellang = 'undelete_'.$what;
	if(!$lang->$undellang) $lang->$undellang = 'Undelete '.ucfirst($what);
	$deleted_modbuttons = '';
	$idname = ($what=='thread'?'t':'p').'id';
	if(is_moderator($fid, $what=='thread'?'canopenclosethreads':'canmanagethreads'))
		$deleted_modbuttons = '<a href="moderation.php?action=do_undelete'.$what.'&amp;'.$idname.'='.$id.'&amp;my_post_key='.$mybb->post_code.'">'.$lang->$undellang.'</a>';
	if($mybb->usergroup['cancp']) {
		$purgelang = 'purge_'.$what;
		if(!$lang->$purgelang) $lang->$purgelang = 'Purge '.ucfirst($what);
		if($deleted_modbuttons) $deleted_modbuttons .= ' &nbsp; ';
		$deleted_modbuttons .= '<a href="moderation.php?action=do_purge'.$what.'&amp;'.$idname.'='.$id.'&amp;my_post_key='.$mybb->post_code.'">'.$lang->$purgelang.'</a>';
	}
}






/*
block custom moderation on deleted threads/posts etc
usercp, if mod, prefix deleted thread with something

test effect on global stats?
test inline mod on forumdisplay + search page
test various combinations of deleted/unapproved posts/threads etc
test custom moderation + delayed moderation, also check that custom tools are blocked in right place (showthread etc)
test counters with merging/moving threads w/ deleted posts

//minor quickreply bug with not going to new page

purge task
admin purge controls

options: excluded forums, admin = direct delete?, mods can see deleted threads?
*/


if(!function_exists('control_object')) {
	function control_object(&$obj, $code) {
		static $cnt = 0;
		$newname = '_objcont_'.(++$cnt);
		$objserial = serialize($obj);
		$classname = get_class($obj);
		$checkstr = 'O:'.strlen($classname).':"'.$classname.'":';
		$checkstr_len = strlen($checkstr);
		if(substr($objserial, 0, $checkstr_len) == $checkstr) {
			$vars = array();
			// grab resources/object etc, stripping scope info from keys
			foreach((array)$obj as $k => $v) {
				if($p = strrpos($k, "\0"))
					$k = substr($k, $p+1);
				$vars[$k] = $v;
			}
			if(!empty($vars))
				$code .= '
					function ___setvars(&$a) {
						foreach($a as $k => &$v)
							$this->$k = $v;
					}
				';
			eval('class '.$newname.' extends '.$classname.' {'.$code.'}');
			$obj = unserialize('O:'.strlen($newname).':"'.$newname.'":'.substr($objserial, $checkstr_len));
			if(!empty($vars))
				$obj->___setvars($vars);
		}
		// else not a valid object or PHP serialize has changed
	}
}
