<?php

if(!defined('IN_MYBB'))
	die('This file cannot be accessed directly.');


$plugins->add_hook('admin_tools_recount_rebuild_forum_counters', 'softdelete_recount_forums');
$plugins->add_hook('admin_tools_recount_rebuild_thread_counters', 'softdelete_recount_threads');
$plugins->add_hook('admin_tools_recount_rebuild_user_posts', 'softdelete_recount_userposts');

$plugins->add_hook('admin_forum_moderation_queue_threads', 'softdelete_adminqueue_threads');
$plugins->add_hook('admin_forum_moderation_queue_posts', 'softdelete_adminqueue_posts');
$plugins->add_hook('admin_forum_moderation_queue_commit', 'softdelete_adminqueue_commit');



function softdelete_info() {
	// check for code edit
	$codeedit_warn = '';
	if(softdelete_is_installed() && $data = @file_get_contents(MYBB_ROOT.'inc/class_moderation.php')) {
		if(!strpos($data, 'softdeletex_approveposts'))
			$codeedit_warn = '<br /><br /><strong style="color: red; font-size: larger;">This plugin requires a code edit to be performed on <em>inc/class_moderation.php</em> which you have not performed!</strong><br />';
		
		unset($data);
	}
	return array(
		'name'			=> 'Soft Delete',
		'description'	=> 'Stops full deleting of posts/threads by users, similar to vB.'.$codeedit_warn,
		'website'		=> 'http://mybbhacks.zingaburga.com/',
		'author'		=> 'ZiNgA BuRgA',
		'authorsite'	=> 'http://zingaburga.com/',
		'version'		=> '1.24',
		'compatibility'	=> '14*,15*,16*',
		'guid'			=> ''
	);
}

function softdelete_install() {
	global $db;
	$db->write_query('ALTER TABLE '.$db->table_prefix.'threads ADD COLUMN `deleted` tinyint(2) not null default 0');
	$db->write_query('ALTER TABLE '.$db->table_prefix.'threads ADD COLUMN `deletedposts` int(10) unsigned not null default 0');
	$db->write_query('ALTER TABLE '.$db->table_prefix.'forums ADD COLUMN `deletedthreads` int(10) unsigned not null default 0');
	$db->write_query('ALTER TABLE '.$db->table_prefix.'posts ADD COLUMN `deleted` tinyint(2) not null default 0');
	// TODO: add various indexes (also drop them in uninstall function)
	
	// insert misc templates
	$db->insert_query('templates', array(
		'title' => 'forumdisplay_thread_deleted',
		'template' => $db->escape_string('
<tr>
	<td align="center" class="{$bgcolor}" width="4%" colspan="2">{$lang->deleted}</td>
	<td class="{$bgcolor}">
		{$attachment_count}
		<div>
			<span>{$prefix} {$gotounread}{$thread[\'threadprefix\']}<a href="{$thread[\'threadlink\']}" class="{$inline_edit_class} {$new_class}" id="tid_{$inline_edit_tid}">{$thread[\'subject\']}</a>{$thread[\'multipage\']}</span>
			<div class="author smalltext">{$thread[\'profilelink\']}</div>
		</div>
	</td>
	<td align="center" class="{$bgcolor}"><a href="javascript:MyBB.whoPosted({$thread[\'tid\']});">{$thread[\'replies\']}</a>{$unapproved_posts}</td>
	<td align="center" class="{$bgcolor}">{$thread[\'views\']}</td>
	<td class="{$bgcolor}" style="white-space: nowrap; text-align: center;" colspan="{$delete_span}">
		{$deleted_modbuttons}
	</td>
{$modbit}
</tr>
		'),
		'sid' => -1,
		'version' => 1600
	));
	$db->insert_query('templates', array(
		'title' => 'search_results_threads_thread_deleted',
		'template' => $db->escape_string('
<tr>
	<td align="center" class="{$bgcolor}" width="4%" colspan="2">{$lang->deleted}</td>
	<td class="{$bgcolor}">
		{$attachment_count}
		<div>
			<span>{$prefix} {$gotounread}{$thread[\'threadprefix\']}<a href="{$thread_link}{$highlight}" class="{$inline_edit_class} {$new_class}" id="tid_{$inline_edit_tid}">{$thread[\'subject\']}</a>{$thread[\'multipage\']}</span>
			<div class="author smalltext">{$thread[\'profilelink\']}</div>
		</div>
	</td>
	<td class="{$bgcolor}">{$thread[\'forumlink\']}</td>
	<td align="center" class="{$bgcolor}"><a href="javascript:MyBB.whoPosted({$thread[\'tid\']});">{$thread[\'replies\']}</a></td>
	<td align="center" class="{$bgcolor}">{$thread[\'views\']}</td>
	<td class="{$bgcolor}" style="white-space: nowrap">
		{$deleted_modbuttons}
	</td>
	{$inline_mod_checkbox}
</tr>
		'),
		'sid' => -1,
		'version' => 1600
	));
	$db->insert_query('templates', array(
		'title' => 'postbit_deleted',
		'template' => $db->escape_string('
{$ignore_bit}
<a name="pid{$post[\'pid\']}" id="pid{$post[\'pid\']}"></a>
<table border="0" cellspacing="{$theme[\'borderwidth\']}" cellpadding="{$theme[\'tablespace\']}" class="tborder" style="{$post_extra_style} {$post_visibility}" id="post_{$post[\'pid\']}">
	<tbody>
		<tr>
			<td class="tcat">
				<div class="float_left smalltext">
					<strong>{$lang->deleted_post}</strong> {$post[\'postdate\']}, {$post[\'posttime\']} <span id="edited_by_{$post[\'pid\']}">{$post[\'editedmsg\']}</span>
				</div>
				{$post[\'posturl\']}
			</td>
		</tr>

		<tr>
			<td class="trow1 {$unapproved_shade}">
				<table cellspacing="0" cellpadding="0" border="0" style="width: 100%;">
					<tr>
						<td>
							<span style="float: right;">{$post[\'deleted_modbuttons\']}</span>
							{$post[\'original_poster\']}<span id="deleted_post_showlink_{$post[\'pid\']}" style="display: none;"> [<a href="#" onclick="$(\'deleted_post_{$post[\'pid\']}\').style.display=\'\';this.parentNode.style.display=\'none\';return false;">{$lang->show_deleted_post}</a>]</span>
						</td>
					</tr>
				</table>
			</td>
		</tr>

		<tr id="deleted_post_{$post[\'pid\']}">
			<td class="trow2 post_content {$unapproved_shade}">
				<span class="smalltext"><strong>{$post[\'icon\']}{$post[\'subject\']} {$post[\'subject_extra\']}</strong></span>

				<div class="post_body" id="pid_{$post[\'pid\']}">
					{$post[\'message\']}
				</div>
				{$post[\'attachments\']}

				<div class="post_meta" id="post_meta_{$post[\'pid\']}">
				{$post[\'iplogged\']}
				</div>
			</td>
		</tr>
	</tbody>
</table>
<script type="text/javascript">
<!--
	$("deleted_post_{$post[\'pid\']}").style.display = "none";
	$("deleted_post_showlink_{$post[\'pid\']}").style.display = "";
//-->
</script>
		'),
		'sid' => -1,
		'version' => 1600
	));
	$db->insert_query('templates', array(
		'title' => 'search_results_posts_post_deleted',
		'template' => $db->escape_string('
<tr>
	<td align="center" class="{$bgcolor}" width="4%" colspan="2">{$lang->deleted}</td>
	<td class="{$bgcolor}">
		<span class="smalltext">
			{$lang->post_thread} <a href="{$thread_url}{$highlight}">{$post[\'thread_subject\']}</a><br />
			{$lang->post_subject} <a href="{$post_url}{$highlight}#pid{$post[\'pid\']}">{$post[\'subject\']}</a>
		</span><br />
		<table width="100%"><tr><td><span class="smalltext"><em>{$prev}</em></span></td></tr></table>
	</td>
	<td align="center" class="{$bgcolor}">{$post[\'profilelink\']}</td>
	<td class="{$bgcolor}" >{$post[\'forumlink\']}</td>
	<td align="center" class="{$bgcolor}"><a href="javascript:MyBB.whoPosted({$post[\'tid\']});">{$post[\'thread_replies\']}</a></td>
	<td align="center" class="{$bgcolor}">{$post[\'thread_views\']}</td>
	<td class="{$bgcolor}" style="white-space: nowrap; text-align: center;"><span class="smalltext">{$deleted_modbuttons}</span></td>
	{$inline_mod_checkbox}
</tr>
		'),
		'sid' => -1,
		'version' => 1600
	));
}
function softdelete_is_installed() {
	return $GLOBALS['db']->field_exists('deleted', 'threads');
}
function softdelete_uninstall() {
	global $db;
	
	require_once MYBB_ROOT.'inc/plugins/softdelete/sd_moderation.php';
	
	// purge deleted threads
	$tids = $pollids = $comma = '';
	$query = $db->simple_select('threads', 'tid,poll', 'deleted!=0');
	while($thread = $db->fetch_array($query)) {
		$tids .= $comma.$thread['tid'];
		$pollids .= $comma.$thread['poll'];
		$comma = ',';
	}
	if($tids)
		softdelete_moderation_do_purge($tids, $pollids);
	
	// purge deleted posts
	$pids = $comma = '';
	$query = $db->simple_select('posts', 'pid', 'deleted!=0');
	while($post = $db->fetch_array($query)) {
		if(!function_exists('remove_attachments')) {
			require_once MYBB_ROOT.'inc/functions_upload.php';
		}
		remove_attachments($post['pid']);
		$pids .= $comma.$post['pid'];
		$comma = ',';
	}
	if($pids) {
		$db->delete_query('posts', 'deleted!=0');
		$db->delete_query('attachments', 'pid IN ('.$pids.')');
		$db->delete_query('reportedposts', 'pid IN ('.$pids.')');
	}
	
	
	$db->write_query('ALTER TABLE '.$db->table_prefix.'threads DROP COLUMN `deleted`');
	$db->write_query('ALTER TABLE '.$db->table_prefix.'threads DROP COLUMN `deletedposts`');
	$db->write_query('ALTER TABLE '.$db->table_prefix.'forums DROP COLUMN `deletedthreads`');
	$db->write_query('ALTER TABLE '.$db->table_prefix.'posts DROP COLUMN `deleted`');
	
	// drop misc templates
	$db->delete_query('templates', 'title IN ("forumdisplay_thread_deleted","search_results_threads_thread_deleted","postbit_deleted","search_results_posts_post_deleted") AND sid=-1');
}





function softdelete_recount_forums() {
	global $db;
	// don't try something too tricky with getting the deleted threads recount to work - just run an extra query to make life much simpler (will ignore the staggered nature of the rebuild, eh, who cares)
	if($GLOBALS['mybb']->input['page'] == 1) {
		$query = $db->simple_select('threads', 'fid,COUNT(tid) AS deletedthreads', 'deleted=1 GROUP BY fid');
		while($f = $db->fetch_array($query)) {
			$db->update_query('forums', array('deletedthreads' => $f['deletedthreads']), 'fid='.$f['fid']);
		}
	}
	control_object($db, '
		function query($string, $hide_errors=0, $write_query=0) {
			if(strpos($string, "SELECT COUNT(tid) AS threads, SUM(replies) AS replies") && strpos($string, " AND visible=\'1\' AND closed	NOT LIKE \'moved|%\'")) {
				$string = str_replace(" AND visible=\'1\' AND closed	NOT LIKE \'moved|%\'", " AND visible=\'1\' AND deleted=\'0\' AND closed	NOT LIKE \'moved|%\'", $string);
			} elseif(strpos($string, "SELECT COUNT(tid) AS threads, SUM(replies) AS impliedunapproved") && strpos($string, " AND visible=\'0\' AND closed NOT LIKE \'moved|%\'")) {
				$string = str_replace(" AND visible=\'0\' AND closed NOT LIKE \'moved|%\'", " AND visible=\'0\' AND deleted=\'0\' AND closed NOT LIKE \'moved|%\'", $string);
			} elseif(strpos($string, "SELECT SUM(unapprovedposts) AS posts")) {
				$string = str_replace(" AND closed NOT LIKE \'moved|%\'", " AND closed NOT LIKE \'moved|%\' AND deleted=0", $string);
			}
			return parent::query($string, $hide_errors, $write_query);
		}
	');
}
function softdelete_recount_threads() {
	control_object($GLOBALS['db'], '
		function simple_select($table, $fields="*", $conditions="", $options=array()) {
			if($table == "posts" && (($fq = ($fields == "COUNT(*) AS replies")) || $fields == "COUNT(pid) AS totunposts") && empty($options)) {
				$conditions .= " AND deleted=0";
				// deleted postcount
				if($fq) {
					$tid = intval(substr($conditions, 5));
					if($tid)
						$this->write_query("UPDATE ".$this->table_prefix."threads SET deletedposts=(SELECT COUNT(pid) FROM ".$this->table_prefix."posts WHERE deleted=1 AND tid=$tid) WHERE tid=$tid");
				}
			}
			return parent::simple_select($table, $fields, $conditions, $options);
		}
	');
}
function softdelete_recount_userposts() {
	/*control_object($GLOBALS['db'], '
		function simple_select($table, $fields="*", $conditions="", $options=array()) {
			if($table == "posts" && $fields == "COUNT(pid) AS post_count" && empty($options))
				$conditions .= " AND deleted=0";
			return parent::simple_select($table, $fields, $conditions, $options);
		}
	');*/
	control_object($GLOBALS['db'], '
		function query($string, $hide_errors=0, $write_query=0) {
			if((strpos($string, "SELECT COUNT(p.pid) AS post_count") || strpos($string, "SELECT COUNT(pid) AS post_count")) && strpos($string, "FROM ".TABLE_PREFIX."posts") && (strpos($string, "WHERE p.uid=") || strpos($string, "WHERE uid=")))
				$string = strtr($string, array("WHERE p.uid=" => "WHERE p.deleted=0 AND t.deleted=0 AND p.uid=", "WHERE uid=" => "WHERE deleted=0 AND uid="));
			return parent::query($string, $hide_errors, $write_query);
		}
	');
}

function softdelete_adminqueue_threads() {
	require_once MYBB_ROOT.'inc/plugins/softdelete/sd_modcp.php';
	softdelete_modqueue_threads_db();
}
function softdelete_adminqueue_posts() {
	require_once MYBB_ROOT.'inc/plugins/softdelete/sd_modcp.php';
	softdelete_modqueue_posts_db(false);
}
function softdelete_adminqueue_commit() {
	require_once MYBB_ROOT.'inc/plugins/softdelete/sd_modcp.php';
	softdelete_modqueue_commit();
}
