<?php

if(!defined('IN_MYBB'))
	die('This file cannot be accessed directly.');


function softdelete_delthread($tid) {
	static $done_ids = null;
	$thread = get_thread($tid);
	if(!$thread['tid']) return;
	if(!isset($done_ids)) $done_ids = array();
	if($done_ids[$thread['tid']]) return;
	else $done_ids[$thread['tid']] = true;
	if(substr($thread['closed'], 0, 6) == 'moved|') return; // allow this to be deleted normally
	if($thread['deleted']) {
		// block ALL DB update routines
		static $dbcont = false;
		if(!$dbcont) {
			$dbcont = true;
			control_object($GLOBALS['db'], '
				function query($string, $hide_errors=0, $write_query=0) {
					if($this->softdelete_blockupdate && strpos($string, "SELECT p.pid, p.uid, p.visible, f.usepostcounts"))
						$string = str_replace("WHERE p.tid=", "WHERE 0=1 AND p.tid=", $string);
					return parent::query($string, $hide_errors, $write_query);
				}
				function write_query($query, $hide_errors=0) {
					if($this->softdelete_blockupdate) return null;
					return parent::write_query($query, $hide_errors);
				}
			');
		}
		$GLOBALS['db']->softdelete_blockupdate = true;
	} else {
		// remove thread from delayed moderation
		global $db;
		if($GLOBALS['mybb']->version_code >= 1500) {
			switch($db->type) {
				case 'pgsql':
				case 'sqlite3':
				case 'sqlite2':
					$query = $db->simple_select('delayedmoderation', 'did,tids', '","||tids||"," LIKE "%,'.$thread['tid'].',%"');
					break;
				default:
					$query = $db->simple_select('delayedmoderation', 'did,tids', 'CONCAT(",",tids,",") LIKE "%,'.$thread['tid'].',%"');
			}
			$delete_dm = array();
			while($dm = $db->fetch_array($query)) {
				$dm['tids'] = str_replace(','.$thread['tid'].',', ',', ','.$dm['tids'].',');
				if($dm['tids'] == ',') $dm['tids'] = '';
				else {
					if($dm['tids']{0} == ',') $dm['tids'] = substr($dm['tids'], 1);
					if($dm['tids']{strlen($dm['tids'])-1} == ',') $dm['tids'] = substr($dm['tids'], 0, -1);
				}
				if($dm['tids'])
					$db->update_query('delayedmoderation', array('tids' => $db->escape_string($dm['tids'])), 'did='.$dm['did']);
				else
					$delete_dm[] = $dm['did'];
			}
			if(!empty($delete_dm))
				$db->delete_query('delayedmoderation', 'did IN ('.implode(',', $delete_dm).')');
		}
		// fix up unapproved post count for threads/forums if we have deleted posts in this thread
		$delcount = $db->fetch_field($db->simple_select('posts', 'COUNT(deleted) AS delposts', 'tid='.$thread['tid'].' AND deleted!=0'), 'delposts');
		if($delcount > 0) {
			//update_thread_counters($thread['tid'], array('unapprovedposts' => '+'.$delcount));
			update_forum_counters($thread['fid'], array('unapprovedposts' => '+'.$delcount));
		}
		// mark first post as deleted (but not unapproved) - perhaps the only place where we have this little discrepancy
		// this is done so that the rebuild user post counts in the admincp works properly
		// we can't rely on $thread['firstpost'] to be accurate (eg split posts)
		//$db->update_query('posts', array('deleted' => 1), 'pid='.$thread['firstpost']);
		$db->update_query('posts', array('deleted' => 1), 'tid='.$thread['tid'].' ORDER BY dateline ASC', 1);
		// update deleted forum+thread counts
		$db->write_query('UPDATE '.$db->table_prefix.'forums SET deletedthreads=deletedthreads+1 WHERE fid='.$thread['fid']);
		$db->write_query('UPDATE '.$db->table_prefix.'threads SET deletedposts=deletedposts+1 WHERE tid='.$thread['tid']);
		softdelete_delhandler($thread['tid']);
	}
	softdelete_delhandler_disable_hooks('thread');
}
/* function softdelete_delthread_helper() {
	global $softdelete_threadcnt;
	$softdelete_threadcnt['posts'] = '+'.$softdelete_threadcnt['posts'];
	$softdelete_threadcnt['unapprovedposts'] = '+'.$softdelete_threadcnt['unapprovedposts'];
	$softdelete_threadcnt['unapprovedthreads'] = '+1';
	update_forum_counters($GLOBALS['softdelete_fid'], $softdelete_threadcnt);
	unset($GLOBALS['softdelete_threadcnt']);
} */
function softdelete_delpost($pid) {
	static $done_ids = null;
	$post = get_post($pid);
	if(!$post['pid']) return;
	if(!isset($done_ids)) $done_ids = array();
	if($done_ids[$post['pid']]) return;
	else $done_ids[$post['pid']] = true;
	$thread = get_thread($post['tid']);
	if($post['deleted'] || $thread['deleted'] || $post['pid'] == $thread['firstpost']) {
		// block ALL DB update routines
		static $dbcont = false;
		if(!$dbcont) {
			$dbcont = true;
			control_object($GLOBALS['db'], '
				function write_query($query, $hide_errors=0) {
					if($this->softdelete_blockupdate) return null;
					return parent::write_query($query, $hide_errors);
				}
			');
		}
		$GLOBALS['db']->softdelete_blockupdate = true;
	} else {
		global $db;
		$db->write_query('UPDATE '.$db->table_prefix.'threads SET deletedposts=deletedposts+1 WHERE tid='.$thread['tid']);
		softdelete_delhandler($pid);
	}
	
	softdelete_delhandler_disable_hooks('post');
	/* if($post['pid'] && $post['deleted'] && $post['visible'] == 0) { // revert counters
		update_thread_counters($post['pid'], array('unapprovedposts' => '+1'));
		update_forum_counters($post['fid'], array('unapprovedposts' => '+1'));
	} */
}
function softdelete_delhandler($id) {
	static $done=false;
	if(!$done && ($done=true)) {
		control_object($GLOBALS['db'], '
			function simple_select($table, $fields="*", $conditions="", $options=array()) {
				if($this->softdelete_intercept && $table == "attachments" && $fields == "*" && empty($options) && substr($conditions, 0, 5) == "pid=\'")
					return parent::simple_select($table, $fields, "1=0");
				
				return parent::simple_select($table, $fields, $conditions, $options);
			}
			function delete_query($table, $where="", $limit="") {
				if($this->softdelete_intercept) {
					switch($table) {
						case "posts":
							if($where == "pid=\'$GLOBALS[softdelete_delhandler_id]\'")
								return $this->update_query($table, array("deleted" => 1, "visible" => 0), $where);
						case "attachments":
						case "polls":
						case "pollvotes":
						case "threadfields_data": case "xtattachments": // XThreads plugin
							return;
						case "threads":
							if($where == "tid=\'$GLOBALS[softdelete_delhandler_id]\'") {
								return $this->update_query($table, array("deleted" => 1, "visible" => 0), $where);
							}
					}
				}
				return parent::delete_query($table, $where, $limit);
			}
		');
	}
	$GLOBALS['softdelete_delhandler_id'] = $id;
	$GLOBALS['db']->softdelete_intercept = true;
}
function softdelete_delhandler_end($tid) { // don't rely on the sent ID
	$GLOBALS['db']->softdelete_intercept = false;
	$GLOBALS['db']->softdelete_blockupdate = false;
	
	global $plugins;
	if(!empty($plugins->hooks['__softdelete__class_moderation_delete_thread'])) {
		$plugins->hooks['class_moderation_delete_thread'] = array_merge($plugins->hooks['class_moderation_delete_thread'], $plugins->hooks['__softdelete__class_moderation_delete_thread']);
		unset($plugins->hooks['__softdelete__class_moderation_delete_thread']);
	}
	if(!empty($plugins->hooks['__softdelete__class_moderation_delete_post'])) {
		$plugins->hooks['class_moderation_delete_post'] = array_merge($plugins->hooks['class_moderation_delete_post'], $plugins->hooks['__softdelete__class_moderation_delete_post']);
		unset($plugins->hooks['__softdelete__class_moderation_delete_post']);
	}
}
function softdelete_delhandler_post_end($pid) {
	// may need to do something different with posts as this hook isn't actually placed at the end of function
	if($GLOBALS['db']->softdelete_blockupdate) {
		// keep blocking updates until the forum cache is updated
		static $cachecont = false;
		if(!$cachecont) {
			$cachecont = true;
			control_object($GLOBALS['cache'], '
				function update_forums() {
					if($GLOBALS["db"]->softdelete_blockupdate) {
						softdelete_delhandler_end(0);
					}
					return parent::update_forums();
				}
			');
		}
	} else
		softdelete_delhandler_end($pid);
}
function softdelete_delhandler_disable_hooks($where) {
	global $plugins;
	
	// handle special softdelete hooks
	$funcname = ($where == 'thread' ? 'softdelete_delhandler_end' : 'softdelete_delhandler_post_end');
	unset($plugins->hooks['class_moderation_delete_'.$where][10][$funcname]);
	
	$plugins->hooks['__softdelete__class_moderation_delete_'.$where] = $plugins->hooks['class_moderation_delete_'.$where];
	unset($plugins->hooks['class_moderation_delete_'.$where]);
	
	$plugins->add_hook('class_moderation_delete_'.$where, $funcname);
}

/*
$plugins->add_hook('moderation_approvethread', 'softdelete_approve');
//multiapprovethreads
function softdelete_approve() {
	global $thread;
	if($thread['deleted'])
		error('This thread has been');
}
*/



function softdelete_approvethreads($tids) {
	$softdelete_appr_counters = array();
	$first_pids = $comma = '';
	foreach($tids as $k => $tid) {
		$thread = get_thread($tid); // will be already cached
		if(!$thread['deleted'] || $thread['visible'] == 1 || !$thread['tid']) {
			unset($tids[$k]);
			continue;
		}
		
		// ... need to bypass if unapprovedposts == 0 check
		if($GLOBALS['mybb']->version_code < 1600 && $thread['unapprovedposts'])
			update_thread_counters($thread['tid'], array('unapprovedposts' => '+1'));
		
		if(!is_array($softdelete_appr_counters[$thread['fid']]))
			$softdelete_appr_counters[$thread['fid']] = array('threads' => 0, 'posts' => 0);
		++$softdelete_appr_counters[$thread['fid']]['threads'];
		$softdelete_appr_counters[$thread['fid']]['posts'] += $thread['replies']+$thread['unapprovedposts']+1;
		
		$first_pids .= $comma.$thread['firstpost'];
		$comma = ',';
	}
	global $db;
	if($tids) {
		//$db->update_query('threads', array('deleted'=>0), 'tid IN ('.implode(',', $tids).')');
		$db->write_query('UPDATE '.$db->table_prefix.'threads SET deleted=0, deletedposts=deletedposts-1 WHERE tid IN ('.implode(',', $tids).')');
	}
	// fix threads' first posts too
	if($first_pids)
		$db->update_query('posts', array('deleted'=>0), 'pid IN ('.$first_pids.')');
	
	/*
	// need to fix _after_ the update_forum_counters() is called to get around negative checking issues
	control_object($GLOBALS['cache'], '
		function update_forums() {
			static $done=false;
			if(!$done) {
				$done = true;
				parent::update_forums();
				softdelete_approvethreads_helper();
			}
			return parent::update_forums();
		}
	');
	*/
	foreach($softdelete_appr_counters as $fid => &$c) {
		update_forum_counters($fid, array(
			'unapprovedthreads' => '+'.$c['threads'],
			'unapprovedposts' => '+'.$c['posts'],
		));
		$db->write_query('UPDATE '.$db->table_prefix.'forums SET deletedthreads=deletedthreads-'.$c['threads'].' WHERE fid='.$fid);
	}
}
/*function softdelete_approvethreads_helper() {
	foreach($GLOBALS['softdelete_appr_counters'] as $fid => &$c) {
		update_forum_counters($fid, array(
			'unapprovedthreads' => strval($c['threads']),
			'unapprovedposts' => strval($c['posts']),
		));
	}
}*/


// following function requires code edit to function properly
function softdeletex_approveposts(&$post) {
	$p = get_post($post['pid']); // this sucks...
	if($p['deleted']) {
		$thread = get_thread($post['tid']);
		return '
			if(!isset($approve[\'deleted\'])) {
				$GLOBALS[\'softdelete_fc\'] =& $forum_counters;
				$GLOBALS[\'softdelete_tc\'] =& $thread_counters;
				$approve[\'deleted\'] = 0;
			}
			++$thread_counters[$post[\'tid\']][\'delposts\'];
			'.($thread['deleted'] ? 
				'--$forum_counters[$post[\'fid\']][\'num_posts\'];'
			:
				'++$forum_counters[$post[\'fid\']][\'num_delposts\'];'
			).'
			softdelete_approveposts_fixfc_inject();
		';
	} else return '';
}
function softdelete_approveposts_fixfc_inject() {
	static $done = false;
	if(!$done) {
		control_object($GLOBALS['db'], '
			function update_query($table, $array, $where="", $limit="", $no_quote=false) {
				if(!$this->softdelete_approveposts_hook && $table == "posts" && count($array) == 2) {
					$this->softdelete_approveposts_hook = true;
					softdelete_approveposts_fixfc();
				}
				return parent::update_query($table, $array, $where, $limit, $no_quote);
			}
		');
		$done = true;
	}
	$GLOBALS['db']->softdelete_approveposts_hook = false;
}
function softdelete_approveposts_fixfc() {
	foreach($GLOBALS['softdelete_fc'] as $fid => &$counters) {
		if($counters['num_delposts']) {
			update_forum_counters($fid, array(
				'unapprovedposts' => '+'.$counters['num_delposts']
			));
			//$counters['unapprovedposts'] -= $counters['num_delposts'];
		}
	}
	
	foreach($GLOBALS['softdelete_tc'] as $tid => &$counters) {
		if($counters['delposts'])
			$counters['unapprovedposts'] -= $counters['delposts'];
		$GLOBALS['db']->write_query('UPDATE '.$GLOBALS['db']->table_prefix.'threads SET deletedposts=deletedposts-'.$counters['delposts'].' WHERE tid='.$tid);
		unset($counters['delposts']);
	}
}

function softdelete_splitpost_fix(&$a) {
	// this is to fix two issues with splitting, causing first post to be deleted: (a) delete thread, (b) amend reply count
	// check if first post of thread is deleted
	global $db;
	$a['tid'] = intval($a['tid']); // paranoia
	if($db->fetch_field($db->simple_select('posts', 'deleted', 'tid='.$a['tid'], array('order_by' => 'dateline', 'limit' => 1)), 'deleted')) {
		// delete thread
		// but we'll be pedantic and double check that it isn't already deleted
		$thread = get_thread($a['tid']);
		if(!$thread['deleted']) {
			global $moderation;
			if(!is_object($moderation)) {
				require_once MYBB_ROOT.'inc/class_moderation.php';
				$moderation = new Moderation;
			}
			//$db->update_query('threads', array('firstpost' => $firstpost['pid']), 'tid='.$a['tid']);
			$moderation->delete_thread($a['tid']);
			// above will increment the delete count by 1, which is unnecessary, since post is already deleted
			$db->write_query('UPDATE '.$db->table_prefix.'threads SET deletedposts=deletedposts-1 WHERE tid='.$a['tid']);
		}
		
		// fix reply counters (need to increase by 1)
		control_object($db, '
			function update_query($table, $array, $where="", $limit="", $no_quote=false) {
				static $done=false;
				if(!$done && $table == "threads" && $where == "tid=\''.$a['tid'].'\'") {
					$done = true;
					++$array[\'replies\'];
				}
				return parent::update_query($table, $array, $where, $limit, $no_quote);
			}
		');
		// fix thread count in source forum (delete does this, but the split post method overrides it)
		// TODO: actually, leave this till later - MyBB should really fix this
		
		/*
		// check if counter will become -1 and set to 0
		if(!$db->fetch_field($db->simple_select('posts', 'pid', 'tid='.$a['tid'].' AND deleted=0', array('limit' => 1)), 'pid')) {
			// all posts in this thread are deleted
		}
		*/
	}
}


// destination thread cannot be deleted, but source thread can be
function softdelete_mergethread_fix(&$a) {
	// allow the upcomming delete to go thru
	// !!! a bit of a dirty hack...
	global $plugins, $db;
	$modfile = MYBB_ROOT.'inc/plugins/softdelete/sd_moderation.php';
	// note that remove_hook, arguments are other way around...
	$plugins->remove_hook('class_moderation_delete_thread_start', 'softdelete_delthread', $modfile, -9999);
	$plugins->remove_hook('class_moderation_delete_thread', 'softdelete_delhandler_end', $modfile, -9999);
	
	// if merging in a deleted thread, fix counters
	$mergethread = get_thread($a['mergetid']);
	if($mergethread['deleted']) {
		$update_forum_counters = array(
			'unapprovedthreads' => '+1',
			'replies' => '+'.$mergethread['replies'],
			'unapprovedposts' => '+'.$mergethread['unapprovedposts']
		);
		$db->write_query('UPDATE '.$db->table_prefix.'forums SET deletedthreads=deletedthreads-1 WHERE fid='.$mergethread['fid']);
		
		// will the first post of this thread (which is deleted) become first post of the merged thread?
		$firstpost = $db->fetch_array($db->simple_select('posts', 'pid,fid,uid,deleted', 'tid='.$a['tid'], array('order_by' => 'dateline', 'limit' => 1)));
		if($firstpost['deleted']) {
			global $forum_cache;
			if(empty($forum_cache)) cache_forums();
			// hmm... we'll approve the post as it's the most convenient thing to do
			$db->update_query('posts', array('visible' => 1, 'deleted' => 0), 'pid='.$firstpost['pid']);
			// TODO: note that MyBB doesn't actually check for whether post counts are considered in the forum, so when that bug gets fixed, this may need changing
			if($forum_cache[$firstpost['fid']]['usepostcounts'] && $firstpost['uid'])
				$db->write_query('UPDATE '.$db->table_prefix.'users SET postnum=postnum+1 WHERE uid='.$firstpost['uid']);
			// $mergethread['deletedposts'] will at least be 1 here - we need to reduce it by 1 (will be committed later)
			--$mergethread['deletedposts'];
			$update_forum_counters['replies'] = '+'.($mergethread['replies']+1);
			// don't need to update thread replies count, because first post is approved and handled by the merge post function
		} else {
			// as first post (of old thread) will be deleted but approved, we need to fix this
			$db->update_query('posts', array('visible' => 0), 'pid='.$mergethread['firstpost']);
		}
		
		// will get overridden by MyBB until they fix their bug
		update_forum_counters($mergethread['fid'], $update_forum_counters);
	}
	// update thread's deletedposts counter
	if($mergethread['deletedposts'] > 0) {
		$db->write_query('UPDATE '.$db->table_prefix.'threads SET deletedposts=deletedposts+'.$mergethread['deletedposts'].' WHERE tid='.$a['tid']);
	}
}


function softdelete_copythread_fix(&$a) {
	static $done = false;
	if($done) return;
	$done = true;
	control_object($GLOBALS['db'], '
		function simple_select($table, $fields="*", $conditions="", $options=array()) {
			if($table == "posts" && $fields == "*" && $conditions == "tid = \''.$a['tid'].'\'") {
				$conditions .= " AND deleted=0";
			}
			return parent::simple_select($table, $fields, $conditions, $options);
		}
	');
}


function softdelete_moderation() {
	global $mybb, $softdelete_dopurge;
	// bypass post action check for certain actions
	switch($mybb->input['action']) {
		case 'do_purgethread':
			$mybb->request_method = 'post';
		break;
		case 'do_purgepost':
			$mybb->request_method = 'post';
			if($mybb->input['pid']) {
				$post = get_post(intval($mybb->input['pid']));
				if(!$post) {
					error($GLOBALS['lang']->error_invalidpost);
				}
				$mybb->input['inlinetype'] = '';
				$mybb->cookies['inlinemod_thread'.$post['tid']] = $post['pid'];
			}
		break;
		case 'do_undeletethread':
			$mybb->request_method = 'post';
			$mybb->input['action'] = 'approvethread';
		break;
		case 'do_undeletepost':
			$mybb->request_method = 'post';
			$pid = intval($mybb->input['pid']);
			$post = get_post($pid);
			if(!$post) {
				error($GLOBALS['lang']->error_invalidpost);
			}
			$mybb->input['action'] = 'multiapproveposts';
			$mybb->input['inlinetype'] = '';
			$mybb->cookies['inlinemod_thread'.$post['tid']] = $post['pid'];
		break;
	}
	switch($mybb->input['action']) {
		// purge actions
		case 'do_purgethread':
			$mybb->input['action'] = 'do_deletethread';
			$softdelete_dopurge = true;
		break;
		case 'do_multipurgethreads':
			$mybb->input['action'] = 'do_deletethread';
			$softdelete_dopurge = 'multi';
		break;
		case 'do_purgepost':
			$mybb->input['action'] = 'do_deleteposts';
			$softdelete_dopurge = true;
		break;
		case 'do_multipurgeposts':
			$mybb->input['action'] = 'do_deleteposts';
			$softdelete_dopurge = true;
		break;
		
		// block some multi* thread actions on deleted threads
		case 'do_multimovethreads':
			if($mybb->input['threads']) {
				$tids = array_map('intval', explode('|', $mybb->input['threads']));
				// search for deleted threads
				if(count($tids) > 0) {
					global $db, $lang;
					if($db->fetch_field($db->simple_select('threads', 'tid', 'tid IN ('.implode(',', $tids).') AND deleted!=0', array('limit' => 1)), 'tid')) {
						if(!$lang->cant_modify_deleted_threads) $lang->cant_modify_deleted_threads = 'Sorry, you cannot manipulate deleted threads.';
						error($lang->cant_modify_deleted_threads);
					}
				}
			}
		break;
		case 'delayedmoderation': case 'do_delayedmoderation':
		case 'multimovethreads':
			if(!$mybb->input['tid']) {
				if($mybb->input['inlinetype'] == 'search') {
					$type = 'search';
					$id = $mybb->input['searchid'];
				} else {
					$type = 'forum';
					$id = $mybb->input['fid'];
				}
				$tids = getids($id, $type);
				if(count($tids) > 0) {
					$tids = array_map('intval', $tids);
					// search for deleted threads
					global $db, $lang;
					if($db->fetch_field($db->simple_select('threads', 'tid', 'tid IN ('.implode(',', $tids).') AND deleted!=0', array('limit' => 1)), 'tid')) {
						if(!$lang->cant_modify_deleted_threads) $lang->cant_modify_deleted_threads = 'Sorry, you cannot manipulate deleted threads.';
						error($lang->cant_modify_deleted_threads);
					}
				}
				break;
			}
			// else fall through
		
		// TODO: block custom tools too
		case 'openclosethread':
		case 'deletethread': case 'do_deletethread':
		case 'deleteposts': case 'do_deleteposts':
		case 'move': case 'do_move':
		case 'stick':
		case 'split': case 'do_split':
		case 'merge': case 'do_merge':
		case 'mergeposts': case 'do_mergeposts':
		case 'deletepoll': case 'do_deletepoll':
		case 'unapprovethread':
		
		case 'multideleteposts': case 'do_multideleteposts':
		case 'multiapproveposts':
		case 'multiunapproveposts':
			$thread = get_thread(intval($mybb->input['tid']));
			if($thread && $thread['deleted']) {
				if(!$lang->cant_modify_deleted_threads) $lang->cant_modify_deleted_threads = 'Sorry, you cannot manipulate deleted threads.';
				error($lang->cant_modify_deleted_threads);
				//error_no_permission();
			}
			
			// unapproving/approving from posts search
			if($mybb->input['inlinetype'] == 'search' && ($mybb->input['action'] == 'multiapproveposts' || $mybb->input['action'] == 'multiunapproveposts')) {
				$pids = getids($mybb->input['searchid'], 'search');
				// check if any of the threads are deleted
				if(!empty($pids)) {
					global $db;
					$pids = implode(',', array_map('intval', $pids));
					if($db->fetch_field($db->query('SELECT t.deleted FROM '.TABLE_PREFIX.'posts p LEFT JOIN '.TABLE_PREFIX.'threads t ON p.tid=t.tid WHERE p.pid IN ('.$pids.') AND t.deleted!=0 LIMIT 1'), 'deleted')) {
						if(!$lang->cant_modify_deleted_threads) $lang->cant_modify_deleted_threads = 'Sorry, you cannot manipulate deleted threads.';
						error($lang->cant_modify_deleted_threads);
					}
				}
			}
		break;
		
		// block splitting/merging deleted posts
		case 'do_multisplitposts':
			isset($pids) or $pids = @explode('|', $mybb->input['posts']);
		case 'do_multimergeposts':
			isset($pids) or $pids = @array_keys($mybb->input['mergepost']);
		case 'multimergeposts':
		case 'multisplitposts':
			if(!isset($pids)) {
				if($mybb->input['inlinetype'] == 'search')
					$pids = getids($mybb->input['searchid'], 'search');
				else
					$pids = getids(intval($mybb->input['tid']), 'thread');
			}
			
			// find deleted posts
			if(!empty($pids) && count($pids) > 0) {
				$pids = array_map('intval', $pids);
				global $db, $lang;
				if($db->fetch_field($db->simple_select('posts', 'pid', 'pid IN ('.implode(',', $pids).') AND deleted!=0', array('limit' => 1)), 'pid')) {
					if(!$lang->cant_mergesplit_deleted_posts) $lang->cant_mergesplit_deleted_posts = 'Sorry, you cannot merge or split deleted posts.';
					error($lang->cant_mergesplit_deleted_posts);
				}
			}
			
			// also check if thread is deleted
			$thread = get_thread(intval($mybb->input['tid']));
			if($thread && $thread['deleted']) {
				if(!$lang->cant_modify_deleted_threads) $lang->cant_modify_deleted_threads = 'Sorry, you cannot manipulate deleted threads.';
				error($lang->cant_modify_deleted_threads);
				//error_no_permission();
			}
		break;
		//case '':
		
		// TODO: block custom moderation too
		/* default: // custom moderation
			$thread = get_thread(intval($mybb->input['tid']));
			if($thread && $thread['deleted'])
				error_no_permission();
		*/
	}
	
	// hide deleted posts from merge/split posts list
	switch($mybb->input['action']) {
		case 'split': case 'mergeposts': case 'deleteposts':
			control_object($GLOBALS['db'], '
				function query($string, $hide_errors=0, $write_query=0) {
					static $done = false;
					if(!$done && strpos($string, "SELECT p.*, u.*") && strpos($string, "ORDER BY dateline ASC")) {
						$done = true;
						$string = str_replace("WHERE tid=\'$GLOBALS[tid]\'", "WHERE tid=\'$GLOBALS[tid]\' AND deleted=0", $string);
					}
					return parent::query($string, $hide_errors, $write_query);
				}
			');
		break;
	}
}
// block splitting thread if trying to split/merge deleted posts
function softdelete_moderation_block_mergesplit() {
	global $mybb, $db;
	if($mybb->input['action'] == 'do_mergeposts')
		$pids =& $mybb->input['mergepost'];
	else
		$pids =& $mybb->input['splitpost'];
	if(!is_array($pids) || empty($pids)) return;
	if($db->fetch_field($db->simple_select('posts', 'pid', 'pid IN ('.implode(',', array_map('intval',array_keys($pids))).') AND deleted=1'), 'pid')) {
		global $lang;
		if(!$lang->cant_mergesplit_deleted_posts) $lang->cant_mergesplit_deleted_posts = 'Sorry, you cannot merge or split deleted posts.';
		error($lang->cant_mergesplit_deleted_posts);
	}
}
function softdelete_moderation_do_purge($tids, $pollids) {
	global $db;
	$tidsq = 'tid IN ('.$tids.')';
	// forum deleted threads counter
	$query = $db->simple_select('threads', 'fid,COUNT(tid) AS threads', $tidsq.' GROUP BY fid');
	while($f = $db->fetch_array($query)) {
		$db->write_query('UPDATE '.$db->table_prefix.'forums SET deletedthreads=deletedthreads-'.$f['threads'].' WHERE fid='.$f['fid']);
	}
	$query = $db->simple_select('posts', 'pid', $tidsq);
	$pids = $comma = '';
	while($pid = $db->fetch_field($query, 'pid')) {
		if(!function_exists('remove_attachments')) {
			require_once MYBB_ROOT.'inc/functions_upload.php';
		}
		remove_attachments($pid);
		$pids .= $comma.$pid;
		$comma = ',';
	}
	if($pids) {
		$db->delete_query('posts', 'pid IN ('.$pids.')');
		$db->delete_query('attachments', 'pid IN ('.$pids.')');
		$db->delete_query('reportedposts', 'pid IN ('.$pids.')');
	}
	$tidarray = array(); $closedin = '';
	$query = $db->simple_select('threads', 'tid', $tidsq);
	while($tid = $db->fetch_field($query, 'tid')) {
		$tidarray[] = $tid;
		$closedin .= ($closedin?',':'') . '"moved|'.$tid.'"';
	}
	$db->delete_query('threads', $tidsq.' OR closed IN ('.$closedin.')');
	$db->delete_query('threadsubscriptions', $tidsq);
	$db->delete_query('polls', $tidsq);
	$db->delete_query('pollvotes', 'pid IN ('.$pollids.')');
	$db->delete_query('threadsread', $tidsq);
	
	foreach($tidarray as $tid)
		$GLOBALS['plugins']->run_hooks('class_moderation_delete_thread', $tid);
	
	/*
	if(defined('XTHREADS_VERSION')) { // XThreads plugin
		$db->delete_query('threadfields_data', $tidsq);
		//$db->delete_query('xtattachments', $tidsq);
		if(!function_exists('xthreads_rm_attach_query')) {
			@include_once MYBB_ROOT.'inc/xthreads/xt_updatehooks.php';
		}
		if(function_exists('xthreads_rm_attach_query'))
			xthreads_rm_attach_query($tidsq);
	}
	*/
}
function softdelete_moderation_purge_thread() {
	global $mybb, $softdelete_dopurge;
	if($softdelete_dopurge === true) {
		global $tid, $modlogdata, $thread, $db, $lang, $fid;
		if(!$mybb->usergroup['cancp'])
			error_no_permission();
		if(!$thread['deleted']) {
			if(!$lang->cannot_purge_not_deleted) $lang->cannot_purge_not_deleted = 'Thread isn\'t deleted, so cannot purge.';
			error($lang->cannot_purge_not_deleted);
		}
		
		$tid = intval($tid);
		// Log the subject of the deleted thread
		$modlogdata['thread_subject'] = $thread['subject'];

		if(!$lang->thread_purged) $lang->thread_purged = 'Purged deleted thread {1}.';
		log_moderator_action($modlogdata, $lang->sprintf($lang->thread_purged, $db->escape_string($thread['subject'])));

		softdelete_moderation_do_purge($tid, $thread['poll']);

		mark_reports($tid, "thread");
		if(!$lang->redirect_threadpurged) $lang->redirect_threadpurged = 'Thread successfully purged.';
		moderation_redirect(get_forum_link($fid), $lang->redirect_threadpurged);
		
		exit;
	}
	elseif($softdelete_dopurge == 'multi') {
		global $mybb, $modlogdata, $lang, $db, $fid;
		// Verify incoming POST request
		verify_post_check($mybb->input['my_post_key']);
		if(!$mybb->usergroup['cancp'])
			error_no_permission();
		
		if(!empty($mybb->input['searchid']))
			$threads = getids($mybb->input['searchid'], 'search');
		else
			$threads = getids($fid, 'forum');

		$tids = array();
		$pollids = $comma = '';
		$query = $db->simple_select('threads', 'tid,poll', 'tid IN ('.implode(',', array_unique(array_map('intval', $threads))).') AND deleted!=0');
		while($thread = $db->fetch_array($query)) {
			//if($thread['deleted']) {
				$tids[] = $thread['tid'];
				$pollids .= $comma.$thread['poll'];
				$comma = ',';
			//}
		}
		if(empty($tids)) {
			if(!$lang->multi_purge_no_threads) $lang->multi_purge_no_threads = 'There are no threads to purge.';
			error($lang->multi_purge_no_threads);
		}
		softdelete_moderation_do_purge(implode(',', $tids), $pollids);
		if(!$lang->multi_purged_threads) $lang->multi_purged_threads = 'Purged multiple threads.';
		log_moderator_action($modlogdata, $lang->multi_purged_threads);
		if($mybb->input['inlinetype'] == 'search')
			clearinline($mybb->input['searchid'], 'search');
		else
			clearinline($fid, 'forum');
		mark_reports($tids, 'threads');
		if(!$lang->redirect_inline_threadspurged) $lang->redirect_inline_threadspurged = 'Successfully purged selected threads.';
		moderation_redirect(get_forum_link($fid), $lang->redirect_inline_threadspurged);
		exit;
	}
}
function softdelete_moderation_purge_posts() {
	global $mybb, $softdelete_dopurge;
	if($softdelete_dopurge) {
		global $modlogdata, $thread, $db, $lang, $fid;
		
		if(!$mybb->usergroup['cancp'])
			error_no_permission();
		
		if(is_array($thread))
			$tid = $thread['tid'];
		
		if($tid && $thread['deleted']) {
			if(!$lang->cant_purge_posts_deleted_thread) $lang->cant_purge_posts_deleted_thread = 'Can\'t purge posts in a deleted thread.';
			error($lang->cant_purge_posts_deleted_thread);
		}
		if($mybb->input['inlinetype'] == 'search')
			$posts = getids($mybb->input['searchid'], 'search');
		else
			$posts = getids($tid, 'thread');
		$deleted = 0;
		if(empty($posts)) {
			error($lang->error_inline_nothreadsselected);
		}
		$pids = $comma = '';
		if($tid) {
			$query = $db->simple_select('posts', 'pid', 'tid='.$tid.' AND pid IN ('.implode(',', $posts).') AND deleted!=0');
		}
		else {
			$query = $db->query('
				SELECT p.pid,t.tid
				FROM '.TABLE_PREFIX.'posts p
				LEFT JOIN '.TABLE_PREFIX.'threads t ON (p.tid=t.tid)
				WHERE p.pid IN ('.implode(',', $posts).') AND p.deleted!=0 AND t.deleted=0
			');
			$tids = array();
		}
		while($post = $db->fetch_array($query)) {
			// purge function
			if(!function_exists('remove_attachments')) {
				require_once MYBB_ROOT.'inc/functions_upload.php';
			}
			remove_attachments($post['pid']);
			$pids .= $comma.$post['pid'];
			$comma = ',';
			++$deleted;
			if(!$tid) ++$tids[$post['tid']]; // thankfully PHP will start at 0
		}
		if($deleted) {
			$db->delete_query('posts', 'pid IN ('.$pids.')');
			$db->delete_query('attachments', 'pid IN ('.$pids.')');
			$db->delete_query('reportedposts', 'pid IN ('.$pids.')');
		} else {
			if(!$lang->multi_purge_no_posts) $lang->multi_purge_no_posts = 'There are no posts to purge.';
			error($lang->multi_purge_no_posts);
		}
		
		foreach(explode(',', $pids) as $pid)
			$GLOBALS['plugins']->run_hooks('class_moderation_delete_post', $pid);
		
		
		if($tid) {
			$db->write_query('UPDATE '.$db->table_prefix.'threads SET deletedposts=deletedposts-'.$deleted.' WHERE tid='.$tid);
			$tids = array($tid);
		}
		else {
			foreach($tids as $tids_tid => $delcount)
				$db->write_query('UPDATE '.$db->table_prefix.'threads SET deletedposts=deletedposts-'.$delcount.' WHERE tid='.$tids_tid);
			$tids = array_keys($tids);
		}
		if($mybb->input['inlinetype'] == 'search')
			clearinline($mybb->input['searchid'], 'search');
		else {
			foreach($tids as $tids_tid)
				clearinline($tids_tid, 'thread');
		}
		foreach($tids as $tids_tid)
			mark_reports($tids_tid, 'thread');
		if(!$lang->purged_selective_posts) $lang->purged_selective_posts = 'Successfully purged {1} posts.';
		log_moderator_action($modlogdata, $lang->sprintf($lang->purged_selective_posts, $deleted));
		if(!$lang->redirect_postspurged) $lang->redirect_postspurged = 'Successfully purged selected posts.';
		if($tid)
			moderation_redirect(get_thread_link($tid), $lang->redirect_postspurged);
		else
			moderation_redirect(get_forum_link($GLOBALS['fid']), $lang->redirect_postspurged);
		
		exit;
	}
}

